/* Autogenerated file. Do not edit manually. */
/* tslint:disable */
/* eslint-disable */

import {
  ethers,
  EventFilter,
  Signer,
  BigNumber,
  BigNumberish,
  PopulatedTransaction,
  BaseContract,
  ContractTransaction,
  Overrides,
  CallOverrides,
} from "ethers";
import { BytesLike } from "@ethersproject/bytes";
import { Listener, Provider } from "@ethersproject/providers";
import { FunctionFragment, EventFragment, Result } from "@ethersproject/abi";
import type { TypedEventFilter, TypedEvent, TypedListener } from "./common";

interface IAccessCardInterface extends ethers.utils.Interface {
  functions: {
    "cardAt(uint256)": FunctionFragment;
    "cardByAddress(address)": FunctionFragment;
    "cardInfo(string)": FunctionFragment;
    "changeKeyPair(string,address,string)": FunctionFragment;
    "createCard(string,address,string)": FunctionFragment;
    "isCardLocked(string)": FunctionFragment;
    "privateKeyOf(string)": FunctionFragment;
    "setLockStatus(string,bool)": FunctionFragment;
    "setNativeAirdopAmount(uint256)": FunctionFragment;
    "totalCards()": FunctionFragment;
  };

  encodeFunctionData(
    functionFragment: "cardAt",
    values: [BigNumberish]
  ): string;
  encodeFunctionData(
    functionFragment: "cardByAddress",
    values: [string]
  ): string;
  encodeFunctionData(functionFragment: "cardInfo", values: [string]): string;
  encodeFunctionData(
    functionFragment: "changeKeyPair",
    values: [string, string, string]
  ): string;
  encodeFunctionData(
    functionFragment: "createCard",
    values: [string, string, string]
  ): string;
  encodeFunctionData(
    functionFragment: "isCardLocked",
    values: [string]
  ): string;
  encodeFunctionData(
    functionFragment: "privateKeyOf",
    values: [string]
  ): string;
  encodeFunctionData(
    functionFragment: "setLockStatus",
    values: [string, boolean]
  ): string;
  encodeFunctionData(
    functionFragment: "setNativeAirdopAmount",
    values: [BigNumberish]
  ): string;
  encodeFunctionData(
    functionFragment: "totalCards",
    values?: undefined
  ): string;

  decodeFunctionResult(functionFragment: "cardAt", data: BytesLike): Result;
  decodeFunctionResult(
    functionFragment: "cardByAddress",
    data: BytesLike
  ): Result;
  decodeFunctionResult(functionFragment: "cardInfo", data: BytesLike): Result;
  decodeFunctionResult(
    functionFragment: "changeKeyPair",
    data: BytesLike
  ): Result;
  decodeFunctionResult(functionFragment: "createCard", data: BytesLike): Result;
  decodeFunctionResult(
    functionFragment: "isCardLocked",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "privateKeyOf",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "setLockStatus",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "setNativeAirdopAmount",
    data: BytesLike
  ): Result;
  decodeFunctionResult(functionFragment: "totalCards", data: BytesLike): Result;

  events: {
    "CardCreated(uint256,string,address)": EventFragment;
    "CardLocked(string)": EventFragment;
    "CardUnlocked(string)": EventFragment;
    "Deposited(uint256)": EventFragment;
    "KeyPairChanged(string,address,address)": EventFragment;
  };

  getEvent(nameOrSignatureOrTopic: "CardCreated"): EventFragment;
  getEvent(nameOrSignatureOrTopic: "CardLocked"): EventFragment;
  getEvent(nameOrSignatureOrTopic: "CardUnlocked"): EventFragment;
  getEvent(nameOrSignatureOrTopic: "Deposited"): EventFragment;
  getEvent(nameOrSignatureOrTopic: "KeyPairChanged"): EventFragment;
}

export type CardCreatedEvent = TypedEvent<
  [BigNumber, string, string] & {
    cardNo_: BigNumber;
    cardIdentity_: string;
    publicKey_: string;
  }
>;

export type CardLockedEvent = TypedEvent<[string] & { cardIdentity_: string }>;

export type CardUnlockedEvent = TypedEvent<
  [string] & { cardIdentity_: string }
>;

export type DepositedEvent = TypedEvent<[BigNumber] & { value: BigNumber }>;

export type KeyPairChangedEvent = TypedEvent<
  [string, string, string] & {
    cardIdentity_: string;
    oldPublicKey_: string;
    newPublicKey_: string;
  }
>;

export class IAccessCard extends BaseContract {
  connect(signerOrProvider: Signer | Provider | string): this;
  attach(addressOrName: string): this;
  deployed(): Promise<this>;

  listeners<EventArgsArray extends Array<any>, EventArgsObject>(
    eventFilter?: TypedEventFilter<EventArgsArray, EventArgsObject>
  ): Array<TypedListener<EventArgsArray, EventArgsObject>>;
  off<EventArgsArray extends Array<any>, EventArgsObject>(
    eventFilter: TypedEventFilter<EventArgsArray, EventArgsObject>,
    listener: TypedListener<EventArgsArray, EventArgsObject>
  ): this;
  on<EventArgsArray extends Array<any>, EventArgsObject>(
    eventFilter: TypedEventFilter<EventArgsArray, EventArgsObject>,
    listener: TypedListener<EventArgsArray, EventArgsObject>
  ): this;
  once<EventArgsArray extends Array<any>, EventArgsObject>(
    eventFilter: TypedEventFilter<EventArgsArray, EventArgsObject>,
    listener: TypedListener<EventArgsArray, EventArgsObject>
  ): this;
  removeListener<EventArgsArray extends Array<any>, EventArgsObject>(
    eventFilter: TypedEventFilter<EventArgsArray, EventArgsObject>,
    listener: TypedListener<EventArgsArray, EventArgsObject>
  ): this;
  removeAllListeners<EventArgsArray extends Array<any>, EventArgsObject>(
    eventFilter: TypedEventFilter<EventArgsArray, EventArgsObject>
  ): this;

  listeners(eventName?: string): Array<Listener>;
  off(eventName: string, listener: Listener): this;
  on(eventName: string, listener: Listener): this;
  once(eventName: string, listener: Listener): this;
  removeListener(eventName: string, listener: Listener): this;
  removeAllListeners(eventName?: string): this;

  queryFilter<EventArgsArray extends Array<any>, EventArgsObject>(
    event: TypedEventFilter<EventArgsArray, EventArgsObject>,
    fromBlockOrBlockhash?: string | number | undefined,
    toBlock?: string | number | undefined
  ): Promise<Array<TypedEvent<EventArgsArray & EventArgsObject>>>;

  interface: IAccessCardInterface;

  functions: {
    cardAt(
      cardNo_: BigNumberish,
      overrides?: CallOverrides
    ): Promise<[string, string, boolean]>;

    cardByAddress(addr_: string, overrides?: CallOverrides): Promise<[string]>;

    cardInfo(
      cardIdentity_: string,
      overrides?: CallOverrides
    ): Promise<[string, boolean]>;

    changeKeyPair(
      cardIdentity_: string,
      publicKey_: string,
      encryptedKey_: string,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<ContractTransaction>;

    createCard(
      cardIdentity_: string,
      publicKey_: string,
      encryptedPrivateKey_: string,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<ContractTransaction>;

    isCardLocked(
      cardIdentity_: string,
      overrides?: CallOverrides
    ): Promise<[boolean]>;

    privateKeyOf(
      cardIdentity_: string,
      overrides?: CallOverrides
    ): Promise<[string]>;

    setLockStatus(
      cardIdentity_: string,
      flag_: boolean,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<ContractTransaction>;

    setNativeAirdopAmount(
      amount_: BigNumberish,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<ContractTransaction>;

    totalCards(overrides?: CallOverrides): Promise<[BigNumber]>;
  };

  cardAt(
    cardNo_: BigNumberish,
    overrides?: CallOverrides
  ): Promise<[string, string, boolean]>;

  cardByAddress(addr_: string, overrides?: CallOverrides): Promise<string>;

  cardInfo(
    cardIdentity_: string,
    overrides?: CallOverrides
  ): Promise<[string, boolean]>;

  changeKeyPair(
    cardIdentity_: string,
    publicKey_: string,
    encryptedKey_: string,
    overrides?: Overrides & { from?: string | Promise<string> }
  ): Promise<ContractTransaction>;

  createCard(
    cardIdentity_: string,
    publicKey_: string,
    encryptedPrivateKey_: string,
    overrides?: Overrides & { from?: string | Promise<string> }
  ): Promise<ContractTransaction>;

  isCardLocked(
    cardIdentity_: string,
    overrides?: CallOverrides
  ): Promise<boolean>;

  privateKeyOf(
    cardIdentity_: string,
    overrides?: CallOverrides
  ): Promise<string>;

  setLockStatus(
    cardIdentity_: string,
    flag_: boolean,
    overrides?: Overrides & { from?: string | Promise<string> }
  ): Promise<ContractTransaction>;

  setNativeAirdopAmount(
    amount_: BigNumberish,
    overrides?: Overrides & { from?: string | Promise<string> }
  ): Promise<ContractTransaction>;

  totalCards(overrides?: CallOverrides): Promise<BigNumber>;

  callStatic: {
    cardAt(
      cardNo_: BigNumberish,
      overrides?: CallOverrides
    ): Promise<[string, string, boolean]>;

    cardByAddress(addr_: string, overrides?: CallOverrides): Promise<string>;

    cardInfo(
      cardIdentity_: string,
      overrides?: CallOverrides
    ): Promise<[string, boolean]>;

    changeKeyPair(
      cardIdentity_: string,
      publicKey_: string,
      encryptedKey_: string,
      overrides?: CallOverrides
    ): Promise<void>;

    createCard(
      cardIdentity_: string,
      publicKey_: string,
      encryptedPrivateKey_: string,
      overrides?: CallOverrides
    ): Promise<void>;

    isCardLocked(
      cardIdentity_: string,
      overrides?: CallOverrides
    ): Promise<boolean>;

    privateKeyOf(
      cardIdentity_: string,
      overrides?: CallOverrides
    ): Promise<string>;

    setLockStatus(
      cardIdentity_: string,
      flag_: boolean,
      overrides?: CallOverrides
    ): Promise<void>;

    setNativeAirdopAmount(
      amount_: BigNumberish,
      overrides?: CallOverrides
    ): Promise<void>;

    totalCards(overrides?: CallOverrides): Promise<BigNumber>;
  };

  filters: {
    "CardCreated(uint256,string,address)"(
      cardNo_?: null,
      cardIdentity_?: null,
      publicKey_?: null
    ): TypedEventFilter<
      [BigNumber, string, string],
      { cardNo_: BigNumber; cardIdentity_: string; publicKey_: string }
    >;

    CardCreated(
      cardNo_?: null,
      cardIdentity_?: null,
      publicKey_?: null
    ): TypedEventFilter<
      [BigNumber, string, string],
      { cardNo_: BigNumber; cardIdentity_: string; publicKey_: string }
    >;

    "CardLocked(string)"(
      cardIdentity_?: null
    ): TypedEventFilter<[string], { cardIdentity_: string }>;

    CardLocked(
      cardIdentity_?: null
    ): TypedEventFilter<[string], { cardIdentity_: string }>;

    "CardUnlocked(string)"(
      cardIdentity_?: null
    ): TypedEventFilter<[string], { cardIdentity_: string }>;

    CardUnlocked(
      cardIdentity_?: null
    ): TypedEventFilter<[string], { cardIdentity_: string }>;

    "Deposited(uint256)"(
      value?: null
    ): TypedEventFilter<[BigNumber], { value: BigNumber }>;

    Deposited(
      value?: null
    ): TypedEventFilter<[BigNumber], { value: BigNumber }>;

    "KeyPairChanged(string,address,address)"(
      cardIdentity_?: null,
      oldPublicKey_?: null,
      newPublicKey_?: null
    ): TypedEventFilter<
      [string, string, string],
      { cardIdentity_: string; oldPublicKey_: string; newPublicKey_: string }
    >;

    KeyPairChanged(
      cardIdentity_?: null,
      oldPublicKey_?: null,
      newPublicKey_?: null
    ): TypedEventFilter<
      [string, string, string],
      { cardIdentity_: string; oldPublicKey_: string; newPublicKey_: string }
    >;
  };

  estimateGas: {
    cardAt(
      cardNo_: BigNumberish,
      overrides?: CallOverrides
    ): Promise<BigNumber>;

    cardByAddress(addr_: string, overrides?: CallOverrides): Promise<BigNumber>;

    cardInfo(
      cardIdentity_: string,
      overrides?: CallOverrides
    ): Promise<BigNumber>;

    changeKeyPair(
      cardIdentity_: string,
      publicKey_: string,
      encryptedKey_: string,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<BigNumber>;

    createCard(
      cardIdentity_: string,
      publicKey_: string,
      encryptedPrivateKey_: string,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<BigNumber>;

    isCardLocked(
      cardIdentity_: string,
      overrides?: CallOverrides
    ): Promise<BigNumber>;

    privateKeyOf(
      cardIdentity_: string,
      overrides?: CallOverrides
    ): Promise<BigNumber>;

    setLockStatus(
      cardIdentity_: string,
      flag_: boolean,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<BigNumber>;

    setNativeAirdopAmount(
      amount_: BigNumberish,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<BigNumber>;

    totalCards(overrides?: CallOverrides): Promise<BigNumber>;
  };

  populateTransaction: {
    cardAt(
      cardNo_: BigNumberish,
      overrides?: CallOverrides
    ): Promise<PopulatedTransaction>;

    cardByAddress(
      addr_: string,
      overrides?: CallOverrides
    ): Promise<PopulatedTransaction>;

    cardInfo(
      cardIdentity_: string,
      overrides?: CallOverrides
    ): Promise<PopulatedTransaction>;

    changeKeyPair(
      cardIdentity_: string,
      publicKey_: string,
      encryptedKey_: string,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<PopulatedTransaction>;

    createCard(
      cardIdentity_: string,
      publicKey_: string,
      encryptedPrivateKey_: string,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<PopulatedTransaction>;

    isCardLocked(
      cardIdentity_: string,
      overrides?: CallOverrides
    ): Promise<PopulatedTransaction>;

    privateKeyOf(
      cardIdentity_: string,
      overrides?: CallOverrides
    ): Promise<PopulatedTransaction>;

    setLockStatus(
      cardIdentity_: string,
      flag_: boolean,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<PopulatedTransaction>;

    setNativeAirdopAmount(
      amount_: BigNumberish,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<PopulatedTransaction>;

    totalCards(overrides?: CallOverrides): Promise<PopulatedTransaction>;
  };
}
