/* Autogenerated file. Do not edit manually. */
/* tslint:disable */
/* eslint-disable */

import {
  ethers,
  EventFilter,
  Signer,
  BigNumber,
  BigNumberish,
  PopulatedTransaction,
  BaseContract,
  ContractTransaction,
  CallOverrides,
} from "ethers";
import { BytesLike } from "@ethersproject/bytes";
import { Listener, Provider } from "@ethersproject/providers";
import { FunctionFragment, EventFragment, Result } from "@ethersproject/abi";
import type { TypedEventFilter, TypedEvent, TypedListener } from "./common";

interface IAccountProviderReferrableInterface extends ethers.utils.Interface {
  functions: {
    "isReferrerOf(uint256,uint256)": FunctionFragment;
    "referLevelBetween(uint256,uint256)": FunctionFragment;
    "referrees(uint256)": FunctionFragment;
    "referrerOf(uint256)": FunctionFragment;
  };

  encodeFunctionData(
    functionFragment: "isReferrerOf",
    values: [BigNumberish, BigNumberish]
  ): string;
  encodeFunctionData(
    functionFragment: "referLevelBetween",
    values: [BigNumberish, BigNumberish]
  ): string;
  encodeFunctionData(
    functionFragment: "referrees",
    values: [BigNumberish]
  ): string;
  encodeFunctionData(
    functionFragment: "referrerOf",
    values: [BigNumberish]
  ): string;

  decodeFunctionResult(
    functionFragment: "isReferrerOf",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "referLevelBetween",
    data: BytesLike
  ): Result;
  decodeFunctionResult(functionFragment: "referrees", data: BytesLike): Result;
  decodeFunctionResult(functionFragment: "referrerOf", data: BytesLike): Result;

  events: {};
}

export class IAccountProviderReferrable extends BaseContract {
  connect(signerOrProvider: Signer | Provider | string): this;
  attach(addressOrName: string): this;
  deployed(): Promise<this>;

  listeners<EventArgsArray extends Array<any>, EventArgsObject>(
    eventFilter?: TypedEventFilter<EventArgsArray, EventArgsObject>
  ): Array<TypedListener<EventArgsArray, EventArgsObject>>;
  off<EventArgsArray extends Array<any>, EventArgsObject>(
    eventFilter: TypedEventFilter<EventArgsArray, EventArgsObject>,
    listener: TypedListener<EventArgsArray, EventArgsObject>
  ): this;
  on<EventArgsArray extends Array<any>, EventArgsObject>(
    eventFilter: TypedEventFilter<EventArgsArray, EventArgsObject>,
    listener: TypedListener<EventArgsArray, EventArgsObject>
  ): this;
  once<EventArgsArray extends Array<any>, EventArgsObject>(
    eventFilter: TypedEventFilter<EventArgsArray, EventArgsObject>,
    listener: TypedListener<EventArgsArray, EventArgsObject>
  ): this;
  removeListener<EventArgsArray extends Array<any>, EventArgsObject>(
    eventFilter: TypedEventFilter<EventArgsArray, EventArgsObject>,
    listener: TypedListener<EventArgsArray, EventArgsObject>
  ): this;
  removeAllListeners<EventArgsArray extends Array<any>, EventArgsObject>(
    eventFilter: TypedEventFilter<EventArgsArray, EventArgsObject>
  ): this;

  listeners(eventName?: string): Array<Listener>;
  off(eventName: string, listener: Listener): this;
  on(eventName: string, listener: Listener): this;
  once(eventName: string, listener: Listener): this;
  removeListener(eventName: string, listener: Listener): this;
  removeAllListeners(eventName?: string): this;

  queryFilter<EventArgsArray extends Array<any>, EventArgsObject>(
    event: TypedEventFilter<EventArgsArray, EventArgsObject>,
    fromBlockOrBlockhash?: string | number | undefined,
    toBlock?: string | number | undefined
  ): Promise<Array<TypedEvent<EventArgsArray & EventArgsObject>>>;

  interface: IAccountProviderReferrableInterface;

  functions: {
    isReferrerOf(
      referrerId_: BigNumberish,
      refereeId_: BigNumberish,
      overrides?: CallOverrides
    ): Promise<[boolean]>;

    referLevelBetween(
      targetReferrerId_: BigNumberish,
      refereeId_: BigNumberish,
      overrides?: CallOverrides
    ): Promise<[BigNumber]>;

    referrees(
      accountId_: BigNumberish,
      overrides?: CallOverrides
    ): Promise<[BigNumber[]]>;

    referrerOf(
      accountId_: BigNumberish,
      overrides?: CallOverrides
    ): Promise<[BigNumber]>;
  };

  isReferrerOf(
    referrerId_: BigNumberish,
    refereeId_: BigNumberish,
    overrides?: CallOverrides
  ): Promise<boolean>;

  referLevelBetween(
    targetReferrerId_: BigNumberish,
    refereeId_: BigNumberish,
    overrides?: CallOverrides
  ): Promise<BigNumber>;

  referrees(
    accountId_: BigNumberish,
    overrides?: CallOverrides
  ): Promise<BigNumber[]>;

  referrerOf(
    accountId_: BigNumberish,
    overrides?: CallOverrides
  ): Promise<BigNumber>;

  callStatic: {
    isReferrerOf(
      referrerId_: BigNumberish,
      refereeId_: BigNumberish,
      overrides?: CallOverrides
    ): Promise<boolean>;

    referLevelBetween(
      targetReferrerId_: BigNumberish,
      refereeId_: BigNumberish,
      overrides?: CallOverrides
    ): Promise<BigNumber>;

    referrees(
      accountId_: BigNumberish,
      overrides?: CallOverrides
    ): Promise<BigNumber[]>;

    referrerOf(
      accountId_: BigNumberish,
      overrides?: CallOverrides
    ): Promise<BigNumber>;
  };

  filters: {};

  estimateGas: {
    isReferrerOf(
      referrerId_: BigNumberish,
      refereeId_: BigNumberish,
      overrides?: CallOverrides
    ): Promise<BigNumber>;

    referLevelBetween(
      targetReferrerId_: BigNumberish,
      refereeId_: BigNumberish,
      overrides?: CallOverrides
    ): Promise<BigNumber>;

    referrees(
      accountId_: BigNumberish,
      overrides?: CallOverrides
    ): Promise<BigNumber>;

    referrerOf(
      accountId_: BigNumberish,
      overrides?: CallOverrides
    ): Promise<BigNumber>;
  };

  populateTransaction: {
    isReferrerOf(
      referrerId_: BigNumberish,
      refereeId_: BigNumberish,
      overrides?: CallOverrides
    ): Promise<PopulatedTransaction>;

    referLevelBetween(
      targetReferrerId_: BigNumberish,
      refereeId_: BigNumberish,
      overrides?: CallOverrides
    ): Promise<PopulatedTransaction>;

    referrees(
      accountId_: BigNumberish,
      overrides?: CallOverrides
    ): Promise<PopulatedTransaction>;

    referrerOf(
      accountId_: BigNumberish,
      overrides?: CallOverrides
    ): Promise<PopulatedTransaction>;
  };
}
